
;**************************************
;     SOFTWARE FOR ET_BOARD VER 4.0   *
;             DISPLAY 8*20            *
;          EXAMPLE PROGRAM 01         *
;**************************************
;

           CPU "Z80.TBL"
           HOF "INT8"

           ORG 2000H

PSCAN:     EQU  21H
DATA:      EQU  20H
CLK:       EQU  22H
CTRL:      EQU  23H
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:  LD   A,80H
       OUT  (CTRL),A
       CALL MIR
MAIN1: CALL SCAND
       JR   MAIN1

;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND: LD   IY,TSL
       LD   B,20
;
       LD   HL,DISBUF
SCAN1: XOR  A
       OUT  (DATA),A
       CALL PULSE
       LD   A,(IY+0)
       OUT  (PSCAN),A
;
       LD   A,(HL)
       OUT  (DATA),A
       CALL PULSE
       CALL DEL
       INC  IY
       INC  HL
       DJNZ SCAN1
       RET
;
;***********************
;   CLOCK 74LS374 SUB. *
;***********************

PULSE: LD   A,C
       SLA  A
       OUT  (CTRL),A
       OR   1
       OUT  (CTRL),A
       RET
;
;***********************
;       DELAY SUB.     *
;***********************
;
DEL:   PUSH AF
       LD   A,20H
DEL1:  DEC  A
       JR   NZ,DEL1
       POP  AF
       RET
;
;***********************
;   MIRROR CHAR. SUB.  *
;***********************

MIR:   LD   HL,ASCII
       LD   DE,DISBUF
       LD   C,20
MIR1:  LD   B,8
MIR2:  RLC  (HL)
       RR   A
       DJNZ MIR2
       LD   (DE),A
       INC  HL
       INC  DE
       DEC  C
       JR   NZ,MIR1
       RET

;
;/* Scan data table */

TSL:   DFB   0F0H,0F1H,0F2H,0F3H,0F4H
       DFB   0F5H,0F6H,0F7H,0F8H,0F9H
       DFB   0FH,1FH,2FH,3FH,4FH
       DFB   5FH,6FH,7FH,8FH,9FH

;
;/* Character for demo */

ASCII: DFB   00H,00H,00H,00H,3EH
       DFB   40H,0F8H,04H,04H,04H
       DFB   04H,04H,04H,06H,05H
       DFB   02H,00H,00H,00H,00H

         ORG   3500H
DISBUF:


         END

