
;**************************************
;     SOFTWARE FOR ET_BOARD VER 4.0   *
;             DISPLAY 8*20            *
;          EXAMPLE PROGRAM 03         *
;**************************************
;

           CPU "Z80.TBL"
           HOF "INT8"

           ORG 2000H

PSCAN:     EQU  21H
DATA:      EQU  20H
CLK:       EQU  22H
CTRL:      EQU  23H
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:  LD   A,80H
       OUT  (CTRL),A
;
       CALL MIR
       LD   HL,DISBUF
       CALL FONT_COV

MAIN1: LD   HL,DISPY
       LD   DE,DISPY+1
       LD   BC,8-1
       LD   (HL),0
       LDIR
;
       CALL SHTL
       JR   MAIN1

;
;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND: PUSH BC
       LD   C,0F0H
       LD   B,8
;
SCAN1: LD   HL,DISPY
       LD   A,0
       OUT  (DATA),A
       CALL PULSE
       LD   A,C
       OUT  (PSCAN),A
;
       LD   E,8            ;8 bit of column is convert
SCAN2: RRC  (HL)           ;
       RRA                 ;data to convert
       DEC  E
       INC  HL
       JR   NZ,SCAN2
;
       OUT  (DATA),A
       CALL PULSE
       CALL DEL
;
       INC  C
       DJNZ SCAN1
       POP  BC
       RET

;
PULSE: LD   A,11111110B
       OUT  (CLK),A
       LD   A,11111111B
       OUT  (CLK),A
       RET


;***********************
;       DELAY SUB.     *
;***********************
;
DEL:   PUSH AF
       LD   A,50H
DEL1:  DEC  A
       JR   NZ,DEL1
       POP  AF
       RET
;
;
;***********************
;      FONT CONVERT    *
;***********************
;
FONT_COV:
       LD   DE,CHR_BUF
       LD   BC,8
       LDIR
       LD   IY,DISBUF

FONT_1:
       LD   HL,CHR_BUF
       LD   B,8

FH:    PUSH HL
       LD   C,8
FONT_2:
       RRC  (HL)
       RR   D
       INC  HL
       DEC  C
       JR   NZ,FONT_2

       LD   (IY+0),D
       INC  IY

       POP  HL
       DEC  B
       JR   NZ,FH
       RET
;
;
MIR:    LD   HL,ASCII
        LD   DE,DISBUF
        LD   C,8
MIR1:   LD   B,8
MIR2:   RLC  (HL)
        RR   A
        DJNZ MIR2
        LD   (DE),A
        INC  HL
        INC  DE
        DEC  C
        JR   NZ,MIR1
        RET
;
;
;***********************
;   shift left display *
;***********************
;
SHTL:  LD   IX,DISBUF
       LD   C,16
SHTL1: LD   HL,DISPY+8-1
       LD   D,(IX+0)
       LD   A,C
       CP   8
       JR   NC,SHTL0
       LD   D,0
SHTL0: LD   B,8
SHTL2: LD   A,(HL)
       LD   (HL),D
       LD   D,A
       DEC  HL
       DJNZ SHTL2
       CALL DSP_LR
       INC  IX
       DEC  C
       JR   NZ,SHTL1
       RET

;
DSP_LR: PUSH BC
        LD   B,50
DSP_L1: CALL SCAND
        DJNZ DSP_L1
        POP  BC
        RET


ASCII:  DFB   0,78H,4,4,7CH,84H,84H,7AH


          ORG  3500H

CHR_BUF: DFS  8
DISBUF:  DFS  8
DISPY:   DFS  8

    END
