
;**************************************
;     SOFTWARE FOR ET_BOARD VER 4.0   *
;              DISPLAY 8*20           *
;           EXAMPLE PROGRAM 04        *
;**************************************
;

           CPU "Z80.TBL"
           HOF "INT8"

           ORG  2000H

PSCAN:     EQU  21H
DATA:      EQU  20H
CLK:       EQU  22H
CTRL:      EQU  23H
NDSP:      EQU  8
BLOCK:     EQU  8*NDSP
;
;
;***********************
;     MAIN PROGRAM     *
;***********************

MAIN:   LD   A,80H
        OUT  (CTRL),A
;
        CALL MIR
        LD   HL,DISBUF
        CALL FONT_COV

MAIN1:  LD   HL,DISPY
        LD   DE,DISPY+1
        LD   BC,BLOCK-1
        LD   (HL),0
        LDIR
;
        CALL  SHTL
        JR   MAIN1
;
;***********************
;      SCAN DISPLAY    *
;***********************

SCAND:  PUSH BC
        PUSH DE
        LD   C,0F0H

SCAN4:  LD   B,NDSP
        LD   D,7
;
SCAN1:  LD   HL,DISPY
        CALL CLEAR
        LD   A,C
        OUT  (PSCAN),A
;
SCAN0:  LD   E,8            ;8 bit of column is convert
SCAN2:  RRC  (HL)           ;
        RRA                 ;data to convert
        DEC  E
        INC  HL
        JR   NZ,SCAN2
;
        OUT  (DATA),A
        CALL PULSE
        DEC  D
        DJNZ SCAN0

        CALL DEL
;
        INC  C
        LD   A,C
        CP   0F8H
        JR   C,SCAN4

        POP  DE
        POP  BC
        RET
;
;***********************
;     CLOCK 74LS374    *
;***********************

PULSE:  LD   A,D
        SLA  A
        OUT  (CTRL),A
        OR   1
        OUT  (CTRL),A
        RET
;
;***********************
;     CLEAR 74LS374    *
;***********************

CLEAR:  PUSH DE
        LD   D,0
        LD   E,NDSP
CLR1:   XOR  A
        OUT  (DATA),A
        CALL PULSE
        INC  D
        DEC  E
        JR   NZ,CLR1
        POP  DE
        RET

;***********************
;       DELAY SUB.     *
;***********************
;
DEL:    PUSH AF
        LD   A,10
DEL1:   DEC  A
        JR   NZ,DEL1
        POP  AF
        RET
;
;***********************
;      FONT CONVERT    *
;***********************
;
FONT_COV:
        LD   DE,CHR_BUF
        LD   BC,BLOCK
        LDIR
        LD   IY,DISBUF
        LD   HL,CHR_BUF
        LD   E,NDSP

FONT_1: LD   B,8
FONT_2: PUSH HL
        LD   C,8
FONT_3: RRC  (HL)
        RR   D
        INC  HL
        DEC  C
        JR   NZ,FONT_3

        LD   (IY+0),D
        INC  IY

        POP  HL
        DJNZ FONT_2
;
        LD   BC,8
        ADD  HL,BC
        DEC  E
        JR   NZ,FONT_1
        RET
;
;***********************
;    MIRROR CHARATER   *
;***********************

MIR:    LD   HL,ASCII
        LD   DE,DISBUF
        LD   C,BLOCK
MIR1:   LD   B,8
MIR2:   RLC  (HL)
        RR   A
        DJNZ MIR2
        LD   (DE),A
        INC  HL
        INC  DE
        DEC  C
        JR   NZ,MIR1
        RET
;
;
;***********************
;   shift left display *
;***********************
;
SHTL:   LD   IX,DISBUF
        LD   C,BLOCK+BLOCK-1
SHTL1:  LD   HL,DISPY+BLOCK-1
        LD   D,(IX+0)
        LD   A,C
        CP   BLOCK
        JR   NC,SHTL0
        LD   D,0
SHTL0:  LD   B,BLOCK
SHTL2:  LD   A,(HL)
        LD   (HL),D
        LD   D,A
        DEC  HL
        DJNZ SHTL2
        CALL DSP_LR
        INC  IX
        DEC  C
        JR   NZ,SHTL1
        RET

;
;***********************
;     DISPLAY LOOP     *
;***********************

DSP_LR: PUSH BC
        LD   B,10
DSP_L1: CALL SCAND
        DJNZ DSP_L1
        POP  BC
        RET

;
;/* CHARACTER TABLE */

ASCII:  DFB   00H,3CH,42H,42H
        DFB   42H,42H,42H,3CH

        DFB   00H,3CH,42H,4AH
        DFB   32H,02H,04H,38H

        DFB   80H,94H,0AAH,0AAH
        DFB   0A2H,0B2H,82H,0FCH

        DFB   00H,6CH,0AAH,92H
        DFB   92H,0C2H,0A2H,44H

        DFB   02H,3CH,40H,80H
        DFB   98H,90H,88H,7CH

        DFB   02H,34H,78H,80H
        DFB   98H,90H,88H,7CH

        DFB   02H,52H,0AAH,0AAH
        DFB   8AH,0CAH,0ACH,48H

        DFB   02H,04H,78H,80H
        DFB   86H,96H,92H,6CH


         ORG  3500H

DISPY:   DFS  BLOCK
CHR_BUF: DFS  BLOCK
DISBUF:  DFS  BLOCK

    END
